" This is the output from a MOO-code @dump command.  To recreate
" this object you should run the @create command and note the object-id
" of the new object you create.  You should then use a text editor
" to search and replace each of the __*__ tokens where they appear
" in this text.
" __NEW__       the object-id of the newly created object
@create $thing named ispell:ispell
@prop __NEW__."task_list" {} rc
;__NEW__.("aliases") = {"ispell"}
;__NEW__.("description") = "UNIX 'ispell'.  Ask it to spell something for you.  When Networker's not around ispell gets a headache."
;__NEW__.("unique") = 0
;__NEW__.("proper") = 1

@verb __NEW__:"event_directed_speech" this none this
@program __NEW__:event_directed_speech
targets = $list_utils:assoc("targets", args[1])[2];
if (this in targets)
  speech = $list_utils:assoc("speech", args[1])[2];
  "... spell 'wibble' ...";
  "... 'wibble' (sp?) ...";
  if ((match = match(speech, "spell *[\"`']*%([a-z]*%)")) || (match = match(speech, "[\"`']*%([a-z]*%)[\"`']* *(sp.*)")))
    range = match[3][1];
    word = speech[range[1]..range[2]];
    if (word == "")
      this:where_are_you():announce_all(this:dnamec(), " says, \"Dur, I'm all confused.  Stick to just [a-z]*\"");
    else
      "can we do this?";
      package = $mcp:match_package("dns-com-awns-ispell");
      if (package:spell(word, this, "handle_reply"))
      else
        this:where_are_you():announce_all(this:dnamec(), " says, \"Aww, I've got a headache, come back later.\"");
      endif
    endif
  else
    this:where_are_you():announce_all(this:dnamec(), " says, \"Uh, what?  You want me to spell something?\"");
  endif
endif
.

@verb __NEW__:"handle_reply" this none this
@program __NEW__:handle_reply
{word, line, @rest} = args;
l = $string_utils:explode(line);
if (l[1] == "&")
  grr = $string_utils:from_list(l[5..$], " ");
  grr = $string_utils:explode(grr, ",");
  words = {};
  for w in (grr)
    words = {@words, $string_utils:trim(w)};
  endfor
  this:where_are_you():announce_all(this:dnamec(), " says, \"Mmm, I dunno about '", word, "', perhaps you mean ", (length(words) == 1) ? "" | "one of: ", $string_utils:english_list(words), "\"");
elseif (l[1] == "+")
  this:where_are_you():announce_all(this:dnamec(), " says, \"Yep, that's how I'd spell '", word, "'\"");
elseif (l[1] == "*")
  this:where_are_you():announce_all(this:dnamec(), " says, \"Yep, that's how I'd spell '", word, "'\"");
elseif (l[1] == "#")
  this:where_are_you():announce_all(this:dnamec(), " says, \"Er, I've no idea what you mean by '", word, "'\"");
endif
.

@verb __NEW__:"spell" this none this
@program __NEW__:spell
":spell(<word>) =>";
"1	word recognised by the UNIX ispell dictionary";
"0	word not recognised";
"0	service unavailable, no client is providing";
"	the ispell service";
"0	request timed out before answer was received";
{word} = args;
package = $mcp:match_package("dns-com-awns-ispell");
record = {word, task_id()};
if (package:spell(word, this, "handle_spell_reply"))
  this.task_list = {@this.task_list, record};
  rv = suspend(3);
  if (typeof(rv) != LIST)
    "CLEAN UP";
    if (psn = record in this.task_list)
      this.task_list = listdelete(this.task_list, psn);
    endif
    return 0;
  else
    "CLEAN UP";
    if (psn = record in this.task_list)
      this.task_list = listdelete(this.task_list, psn);
    endif
    {word, line, @rest} = rv;
    l = $string_utils:explode(line);
    if (l[1] in {"+", "*"})
      return 1;
    else
      return 0;
    endif
  endif
else
  return 0;
endif
.

@verb __NEW__:"handle_spell_reply" this none this
@program __NEW__:handle_spell_reply
{word, line, @rest} = args;
if (psn = $list_utils:iassoc(word, this.task_list))
  `resume(this.task_list[psn][2], args) ! ANY';
endif
.

"***finished***
